summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
-rw-r--r--usr.bin/mktemp/Makefile5
-rw-r--r--usr.bin/mktemp/mktemp.1130
-rw-r--r--usr.bin/mktemp/mktemp.c97
3 files changed, 232 insertions, 0 deletions
diff --git a/usr.bin/mktemp/Makefile b/usr.bin/mktemp/Makefile
new file mode 100644
index 00000000000..893632d5caa
--- /dev/null
+++ b/usr.bin/mktemp/Makefile
@@ -0,0 +1,5 @@
+# $OpenBSD: Makefile,v 1.1 1996/11/21 07:59:31 millert Exp $
+
+PROG= mktemp
+
+.include <bsd.prog.mk>
diff --git a/usr.bin/mktemp/mktemp.1 b/usr.bin/mktemp/mktemp.1
new file mode 100644
index 00000000000..4f6ff85d8c1
--- /dev/null
+++ b/usr.bin/mktemp/mktemp.1
@@ -0,0 +1,130 @@
+.\" $OpenBSD: mktemp.1,v 1.1 1996/11/21 07:59:32 millert Exp $
+.\"
+.\" Copyright (c) 1989, 1991, 1993
+.\" The Regents of the University of California. All rights reserved.
+.\"
+.\" Redistribution and use in source and binary forms, with or without
+.\" modification, are permitted provided that the following conditions
+.\" are met:
+.\" 1. Redistributions of source code must retain the above copyright
+.\" notice, this list of conditions and the following disclaimer.
+.\" 2. Redistributions in binary form must reproduce the above copyright
+.\" notice, this list of conditions and the following disclaimer in the
+.\" documentation and/or other materials provided with the distribution.
+.\" 3. All advertising materials mentioning features or use of this software
+.\" must display the following acknowledgement:
+.\" This product includes software developed by the University of
+.\" California, Berkeley and its contributors.
+.\" 4. Neither the name of the University nor the names of its contributors
+.\" may be used to endorse or promote products derived from this software
+.\" without specific prior written permission.
+.\"
+.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
+.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+.\" ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
+.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+.\" SUCH DAMAGE.
+.\"
+.Dd "November 20, 1996"
+.Dt MKTEMP 1
+.Os
+.Sh NAME
+.Nm mktemp
+.Nd make temporary file name (unique)
+.Sh SYNOPSIS
+.Nm mktemp
+.Op Fl u
+.Op Fl q
+.Ar template
+.Sh DESCRIPTION
+The
+.Nm mktemp
+utility takes the given file name template and overwrites a
+portion of it to create a file name. This file name is unique
+and suitable for use by the application. The template may be
+any file name with some number of
+.Ql X Ns s
+appended
+to it, for example
+.Pa /tmp/temp.XXXX .
+The trailing
+.Ql X Ns s
+are replaced with the current process number and/or a
+unique letter combination.
+The number of unique file names
+.Nm
+can return depends on the number of
+.Ql X Ns s
+provided; six
+.Ql X Ns s
+will
+result in
+.Nm
+testing roughly 26 ** 6 combinations.
+.Pp
+If
+.Nm
+can successfully generate a unique file name, the file
+is created with mode 0600 (unless the
+.Fl u
+flag is given) and the filename is printed
+to standard output.
+.Sh OPTIONS
+.Bl -tag -width indent
+The available options are as follows:
+.It Fl u
+Operate in
+.Dq unsafe
+mode. The temp file will be unlinked before
+.Nm
+exits. This is slightly better than
+.Fn mktemp 3
+but still introduces a race condition. Use of this
+option is not encouraged.
+.It Fl q
+Fail silently if an error occurs. This is useful if
+a script does not want error output to go to standard error.
+.Sh RETURN VALUES
+The
+.Nm
+utility
+exits with a value of 0 on success, and 1 on failure.
+.Sh EXAMPLES
+The following
+.Xr sh 1
+fragment illustrates a simple use of
+.Nm
+where the script should quit if it cannot get a safe
+temporary file.
+.Bd -literal -offset indent
+TMPFILE=`mktemp /tmp/$0.XXXXXX` || exit 1
+echo "program output" >> $TMPFILE
+.Ed
+.Pp
+In this case, we want the script to catch the error itself.
+.Bd -literal -offset indent
+TMPFILE=`mktemp -s /tmp/$0.XXXXXX`
+if [ $? ne 0 ]; then
+ echo "$0: Can't create temp file, exiting..."
+ exit 1
+fi
+.Ed
+.Pp
+Note that one can also check to see that $TMPFILE is
+zero length instead of checking $?. This would allow
+the check to be done later one in the script (since
+$? would get clobbered by the next shell command).
+.Sh SEE ALSO
+.Xr mkstemp 3 ,
+.Xr mktemp 3
+.Sh HISTORY
+The
+.Nm
+utility appeared in
+.Bx Open .
diff --git a/usr.bin/mktemp/mktemp.c b/usr.bin/mktemp/mktemp.c
new file mode 100644
index 00000000000..666fd4f00b1
--- /dev/null
+++ b/usr.bin/mktemp/mktemp.c
@@ -0,0 +1,97 @@
+/* $OpenBSD: mktemp.c,v 1.1 1996/11/21 07:59:33 millert Exp $ */
+
+/*
+ * Copyright (c) 1996 Todd C. Miller <Todd.Miller@courtesan.com>
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ * 1. Redistributions of source code must retain the above copyright
+ * notice, this list of conditions and the following disclaimer.
+ * 2. Redistributions in binary form must reproduce the above copyright
+ * notice, this list of conditions and the following disclaimer in the
+ * documentation and/or other materials provided with the distribution.
+ * 3. All advertising materials mentioning features or use of this software
+ * must display the following acknowledgement:
+ * This product includes software developed by Todd C. Miller.
+ * 4. The name of the author may not be used to endorse or promote products
+ * derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
+ * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
+ * AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
+ * THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
+ * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+ * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+ * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+ * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+ * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+ * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+#ifndef lint
+static char rcsid[] = "$OpenBSD: mktemp.c,v 1.1 1996/11/21 07:59:33 millert Exp $";
+#endif /* not lint */
+
+#include <stdio.h>
+#include <stdlib.h>
+#include <string.h>
+#include <unistd.h>
+#include <err.h>
+
+extern char *__progname;
+
+void
+usage()
+{
+ (void) fprintf(stderr, "Usage: %s [-u] [-q] template\n", __progname);
+ exit(1);
+}
+
+int
+main(argc, argv)
+ int argc;
+ char **argv;
+{
+ char *template;
+ int ch, uflag = 0, qflag = 0;
+
+ while ((ch = getopt(argc, argv, "uq")) != -1)
+ switch(ch) {
+ case 'u':
+ uflag = 1;
+ break;
+ case 'q':
+ qflag = 1;
+ break;
+ case '?':
+ default:
+ usage();
+ }
+
+ if (argc - optind != 1)
+ usage();
+
+ if ((template = strdup(argv[optind])) == NULL) {
+ if (qflag)
+ exit(1);
+ else
+ errx(1, "Cannot allocate memory");
+ }
+
+ if (mkstemp(template) < 0) {
+ if (qflag)
+ exit(1);
+ else
+ err(1, "Cannot create temp file");
+ }
+
+ if (uflag)
+ (void) unlink(template);
+
+ (void) puts(template);
+ free(template);
+
+ exit(0);
+}